#!/usr/bin/perl

#use strict;
use Gtk;
use Gtk::Atoms;

init Gtk;

sub destroy_window {
        my($widget, $windowref, $w2) = @_;
        $$windowref = undef;
        $w2 = undef if defined $w2;
        0;
}

sub do_exit {
        Gtk->exit(0);
}

sub list_add
{
        my($widget,$list) = @_;
#Gtk->container_get_object_type($widget, $list);
#$var = $list->selection;
#$var =  Gtk::List::select_item ($list, "frmug");
#$var = $list->get_object_type($widget);

$autre = Gtk::Object::get_user_data($list);

$dlist = Gtk::List($list->selection);

#printf"jo: %s\n", $list->get($list);
printf "kl: %d\n", $autre;
        Gtk->print("$var\n");
}

sub list_remove
{
        my($widget, $list) = @_;

        $list->remove_items($list->selection);
}

sub create_list
{
    local(@list_items) = @_;
 
my($box1,$box2,$scrolled_win,$list,$list_item,$button,$separator,$i);

        @titles = (
            "Title 0",
            "Title 1",
            "Title 2",
            "Title 3",
            "Title 4",
            "Title 5",
            "Title 6"
        );

        if (not defined $list_window) {
                $list_window = new Gtk::Window "toplevel";
                $list_window->signal_connect("destroy", \&destroy_window, \$list_window);
                $list_window->signal_connect("delete_event", \&destroy_window, \$list_window);
                $list_window->set_title("Configuration");
                $list_window->border_width(0);

                $box1 = new Gtk::VBox(0,0);
                $list_window->add($box1);
                $box1->show;

                $box2 = new Gtk::VBox(0, 10);
                $box2->border_width(10);
                $box1->pack_start($box2, 1, 1, 0);
                $box2->show;

                $scrolled_win = new Gtk::ScrolledWindow(undef, undef);
                $scrolled_win->set_policy(-automatic, -automatic);
                $box2->pack_start($scrolled_win, 1, 1, 0);
                $scrolled_win->show;

                $list = new Gtk::List;
                $list->set_selection_mode(-multiple);
                $list->set_selection_mode(-browse);
                $scrolled_win->add($list);
                $list->show;

                $list->set_selection_mode('browse');
                #$list->set_policy ('automatic', 'automatic');

                for($i=0;$i<@list_items;$i++)
                {
                        $list_item = new Gtk::ListItem($list_items[$i]);
                        $list->add($list_item);
                        $list_item->show;
                }

# Quand je clique sur le nom d'une machine je lance list_add.
$list->signal_connect("select_child", \&list_add);



                $button = new Gtk::Button "Ajouter";
                $button->can_focus(0);

                $button->signal_connect("clicked", \&list_add, $list);
                $box2->pack_start($button, 0, 1, 0);
                $button->show;

                $button = new Gtk::Button "Modifier";
                $button->can_focus(0);
                $button->signal_connect("clicked", \&list_remove, $list);
                $box2->pack_start($button, 0, 0, 0);
                $button->show;

                $separator = new Gtk::HSeparator;
                $box1->pack_start($separator, 0, 1, 0);
                $separator->show;

                $box2 = new Gtk::VBox(0,10);
                $box2->border_width(30);
                $box1->pack_start($box2, 0, 1, 0);
                $box2->show;

                $button = new Gtk::Button "Quitter";
                $button->signal_connect("clicked", \&do_exit);
                #$button->signal_connect("clicked", sub { destroy $list_window}, \&do_exit);
                $box2->pack_start($button, 1, 1, 0);
                $button->can_default(1);
                $button->grab_default;
                $button->show;


        }
        if (not $list_window->visible) {
                show $list_window;
        } else {
                destroy $list_window;
        }
}


sub create_main_window {
        my(@buttons,$window,$box1,$scw, $box2,$button,$separator);
        @buttons = (
                "buttons",      \&create_buttons,
                "configuration list",  \&create_list,
        );

        $window = new Gtk::Window('toplevel');
        $window->set_name("main window");
        $window->set_uposition(20, 20);
        $window->set_usize(200, 400);

        $window->signal_connect("destroy" => \&destroy_window, \$window);
        $window->signal_connect("delete_event" => \&destroy_window, \$window);

        $box1 = new Gtk::VBox(0, 0);
        $window->add($box1);
        $box1->show;

        $scw = new Gtk::ScrolledWindow(undef, undef);
        $scw->set_policy('automatic', 'automatic');
        $scw->show;
        $scw->border_width(10);

        $box2 = new Gtk::VBox(0, 0);
        #border_width $box2 10;
        $box1->pack_start($scw, 1, 1, 0);
        $box2->show;
        $box2->border_width(10);
        $scw->add($box2);

        for($i=0;$i<@buttons;$i+=2) {
                $button = new Gtk::Button($buttons[$i]);
                if (defined $buttons[$i+1]) {
                        $button->signal_connect(clicked => $buttons[$i+1]);
                } else {
                        $button->set_sensitive(0);
                }
                $box2->pack_start($button, 1, 1, 0);
                show $button;
        }

        $separator = new Gtk::HSeparator;
        $box1->pack_start($separator, 0, 1, 0);
        $separator->show;

        $box2 = new Gtk::VBox(0, 10);
        $box2->border_width(10);
        $box1->pack_start($box2, 0, 1, 0);
        $box2->show();

        $button = new Gtk::Button "close";
        signal_connect $button "clicked", \&do_exit;
        $box2->pack_start($button, 1, 1, 0);
        $button->can_default(1);
        $button->grab_default();
        $button->show;

        $window->show;

}


#create_main_window;
#create_list;

#main Gtk;

1;
